#include <DFRobot_HX711.h>
#include <ArduinoJson.h>

#include "DFRobot_BC20.h"
#include "DFRobot_Iot.h"

#define BEDROOD_LIGHT  D4

/*Configure device certificate information*/
String ProductKey = "a1CFyLjTVM5";
String ClientId = "1125567943";/*Custom id*/
String DeviceName = "gTlmptyZKOqFPjN8PAdm";
String DeviceSecret = "5f2411cf1bf5ea8c5fe324035524dec5";

/*Configure the domain name and port number*/
String ALIYUN_SERVER = "iot-as-mqtt.cn-shanghai.aliyuncs.com";
uint16_t PORT = 1883;

/*Product identifier that needs to be operated*/
String Identifier = "auto_buy";

/*TOPIC that need to be published and subscribed*/
const char * subTopic = "/sys/a1CFyLjTVM5/gTlmptyZKOqFPjN8PAdm/thing/service/property/set";//****set
const char * pubTopic = "/sys/a1CFyLjTVM5/gTlmptyZKOqFPjN8PAdm/thing/event/property/post";//******post
DFRobot_BC20 myBC20;
DFRobot_Iot myDevice;
DFRobot_HX711 MyScale(D2, D3);
bool state = 0;
void callback(char * topic, byte * payload, unsigned int len) {
  Serial.print("Recevice [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < len; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();
}

void ConnectCloud() {
  while (!myBC20.connected()) {
    Serial.print("Attempting MQTT connection...");
    if (myBC20.connect(myDevice._clientId, myDevice._username, myDevice._password)) {
      Serial.println("Connect Server OK");
    } else {
      myBC20.getQMTCONN();
    }
  }
}
void setup() {
  Serial.begin(115200);
  Serial.print("Starting the BC20.Please wait. . . ");
  while (!myBC20.powerOn()) {
    delay(1000);
    Serial.print(".");
  }
  Serial.println("BC20 started successfully !");
  while (!myBC20.checkNBCard()) {
    Serial.println("Please insert the NB card !");
    delay(1000);
  }
  Serial.println("Waitting for access ...");
  while (myBC20.getGATT() == 0) {
    Serial.print(".");
    delay(1000);
  }
  myDevice.init(ALIYUN_SERVER, ProductKey, ClientId, DeviceName, DeviceSecret);
  myBC20.setServer(myDevice._mqttServer, PORT);
  myBC20.setCallback(callback);
  ConnectCloud();
  //myBC20.publish(pubTopic, ("{\"id\":" + ClientId + ",\"params\":{\"" + Identifier + "\":1},\"method\":\"thing.event.property.post\"}").c_str());
  pinMode(BEDROOD_LIGHT, OUTPUT);
}

void loop() {
  Serial.print(MyScale.readWeight(), 1);
  Serial.println("g");
  if (MyScale.readWeight() > 600 && state == 0 && MyScale.readWeight() < 3000) {
    state = 1;
    digitalWrite(BEDROOD_LIGHT, LOW);
  }
  if (MyScale.readWeight() < 400 && state == 1 && MyScale.readWeight() > 20) {
    state = 0;
    digitalWrite(BEDROOD_LIGHT, HIGH);
    for (int i = 1; i < 6; i++) {
      Serial.print("第几次上传次数：");
      Serial.println(i);
      myBC20.publish(pubTopic, ("{\"id\":" + ClientId + ",\"params\":{\"" + Identifier + "\":"+state+"},\"method\":\"thing.event.property.post\"}").c_str());
      myBC20.loop();
      Serial.println("Data is published to cloud.");
      delay(12000);
    }
  }
    Serial.print(MyScale.readWeight(), 1);
    Serial.println("g");
    delay(500);

}
